package com.akamai.hdcore.samples.utility
{
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.ContextMenuEvent;
	import flash.events.Event;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.net.SharedObject;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	
	/**
	 * 
	 * 
	 */	
	public class BaseSample extends Sprite
	{
		protected var view:Sprite;
		protected var netConnection:NetConnection;
		protected var netStream:NetStream;
		protected var presenter:BasePresenter;
		protected var currentScaleMode:String;
		protected var sharedObject:SharedObject;
		
		protected var enableTrace:Boolean = true;
		
		/**
		 * 
		 * 
		 */		
		public function BaseSample()
		{
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			sharedObject = SharedObject.getLocal("AkamaiControlBarProperties");
			if(sharedObject.data.scaleMode)
			{
				currentScaleMode = sharedObject.data.scaleMode;
			}
			addContextMenu();
		}

		/**
		 * 
		 * @param event
		 * 
		 */		
		protected function onAddedToStage(event:Event):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage)
			setStageProperties();
			addView();
			initNetConnection();
		}
		
		/**
		 * 
		 * @return 
		 * 
		 */		
		protected function getPresenter():BasePresenter
		{
			return null;
		}
		
		/**
		 * 
		 * 
		 */		
		protected function initNetConnection():void
		{
			netConnection = getNetConnection()
			netConnection.connect(null);
			initNetStream();
		}
		
		protected function getNetConnection():NetConnection
		{
			return new NetConnection();	
		}
		
		/**
		 * 
		 * 
		 */		
		protected function initNetStream():void
		{
			netStream = getNetStream();			
			presenter = getPresenter();
		}
		
		/**
		 * 
		 * @return 
		 * 
		 */		
		protected function getNetStream():NetStream
		{
			return null;	
		}
		
		/**
		 * 
		 * 
		 */		
		protected function addView():void
		{
			addChild(view = getView())
		}
		
		/**
		 * 
		 * @return 
		 * 
		 */		
		protected function getView():Sprite
		{
			return null
		}

		/**
		 * 
		 * 
		 */		
		protected function setStageProperties():void
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
		}
		
		/**
		 * 
		 * 
		 */		
		protected function addContextMenu():void
		{
			contextMenu = new ContextMenu();	
			contextMenu.hideBuiltInItems();
			contextMenu.customItems.push(getContextItem("Toggle Trace Output", onToggleTrace, true));
			contextMenu.customItems.push(getContextItem("Toggle Debug Panel", onToggleDebugConsole, true));
			contextMenu.customItems.push(getContextItem("Toggle Scale Mode", onToggleScaleMode, true));
		}
		
		protected function onToggleTrace(event:ContextMenuEvent):void
		{
		}
		
		/**
		 * 
		 * @param event
		 * 
		 */		
		protected function onToggleScaleMode(event:ContextMenuEvent):void
		{
			if (view is MediaPlayerView)
			{
				var mode:String = (currentScaleMode == null || currentScaleMode == Utils.SCALE_MODE_NATIVE) 
								? Utils.SCALE_MODE_FIT 
								: Utils.SCALE_MODE_NATIVE;
				
				sharedObject.data.scaleMode = mode;
				currentScaleMode = mode;
				Utils.doScaleMode(view, mode, 640, 360);
			}
			
		}
		
		/**
		 * 
		 * @param title
		 * @param handler
		 * @param seperate
		 * @return 
		 * 
		 */		
		protected function getContextItem(title:String, handler:Function, seperate:Boolean = false):ContextMenuItem
		{
			var item:ContextMenuItem = new ContextMenuItem(title,  seperate);
			item.addEventListener( ContextMenuEvent.MENU_ITEM_SELECT , handler as Function);
			return item as ContextMenuItem;
		}
		
		/**
		 * 
		 * @param event
		 * 
		 */		
		protected function onToggleDebugConsole(event:ContextMenuEvent):void
		{
			if (view is MediaPlayerView)
			{
				if(MediaPlayerView(view).console != null)
				{
					MediaPlayerView(view).console.visible = !MediaPlayerView(view).console.visible;
				}
			}
		}
	}
}
